Package org.apache.lucene.search

# Class IndexSortSortedNumericDocValuesRangeQuery

java.lang.Object
org.apache.lucene.search.Query
org.apache.lucene.search.IndexSortSortedNumericDocValuesRangeQuery

public class IndexSortSortedNumericDocValuesRangeQuery extends Query
A range query that can take advantage of the fact that the index is sorted to speed up execution. If the index is sorted on the same field as the query, it performs binary search on the field's numeric doc values to find the documents at the lower and upper ends of the range.

This optimized execution strategy is only used if the following conditions hold:

- The index is sorted, and its primary sort is on the same field as the query.
- The query field has either `SortedNumericDocValues` or `NumericDocValues`.
- The sort field is of type `SortField.Type.LONG` or `SortField.Type.INT`.
- The segments must have at most one field value per document (otherwise we cannot easily determine the matching document IDs through a binary search).

If any of these conditions isn't met, the search is delegated to `fallbackQuery`.

This fallback must be an equivalent range query -- it should produce the same documents and give constant scores. As an example, an `IndexSortSortedNumericDocValuesRangeQuery` might be constructed as follows:

       String field = "field";
       long lowerValue = 0, long upperValue = 10;
       Query fallbackQuery = LongPoint.newRangeQuery(field, lowerValue, upperValue);
       Query rangeQuery = new IndexSortSortedNumericDocValuesRangeQuery(
           field, lowerValue, upperValue, fallbackQuery);

WARNING: This API is experimental and might change in incompatible ways in the next release.

## Constructor Summary

Constructors
Constructor
Description
`IndexSortSortedNumericDocValuesRangeQuery(String field, long lowerValue, long upperValue, Query fallbackQuery)`
Creates a new `IndexSortSortedNumericDocValuesRangeQuery`.

## Method Summary

Modifier and Type
Method
Description
`Weight`
`createWeight(IndexSearcher searcher, ScoreMode scoreMode, float boost)`
Expert: Constructs an appropriate Weight implementation for this query.
`boolean`
`equals(Object o)`
Override and implement query instance equivalence properly in a subclass.
`Query`
`getFallbackQuery()`
`int`
`hashCode()`
Override and implement query hash code properly in a subclass.
`Query`
`rewrite(IndexSearcher indexSearcher)`
Expert: called to re-write queries into primitive queries.
`String`
`toString(String field)`
Prints a query to a string, with `field` assumed to be the default field and omitted.
`void`
`visit(QueryVisitor visitor)`
Recurse through the query tree, visiting any child queries.

### Methods inherited from class org.apache.lucene.search.Query

`classHash, sameClassAs, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Constructor Details

### IndexSortSortedNumericDocValuesRangeQuery

public IndexSortSortedNumericDocValuesRangeQuery(String field, long lowerValue, long upperValue, Query fallbackQuery)
Creates a new `IndexSortSortedNumericDocValuesRangeQuery`.

Parameters:
  `field` - The field name.
  `lowerValue` - The lower end of the range (inclusive).
  `upperValue` - The upper end of the range (exclusive).
  `fallbackQuery` - A query to fall back to if the optimization cannot be applied.

## Method Details

### getFallbackQuery

public Query getFallbackQuery()

### equals

public boolean equals(Object o)
Description copied from class: `Query`
Override and implement query instance equivalence properly in a subclass. This is required so that `QueryCache` works properly.

Typically a query will be equal to another only if it's an instance of the same class and its document-filtering properties are identical to those of the other instance. Utility methods are provided for certain repetitive code.

Specified by:
  `equals` in class `Query`
See Also:
  - `Query.sameClassAs(Object)`
  - `Query.classHash()`

### hashCode

public int hashCode()
Description copied from class: `Query`
Override and implement query hash code properly in a subclass. This is required so that `QueryCache` works properly.

Specified by:
  `hashCode` in class `Query`
See Also:
  - `Query.equals(Object)`

### visit

public void visit(QueryVisitor visitor)
Description copied from class: `Query`
Recurse through the query tree, visiting any child queries.

Specified by:
  `visit` in class `Query`
Parameters:
  `visitor` - a QueryVisitor to be called by each query in the tree

### toString

public String toString(String field)
Description copied from class: `Query`
Prints a query to a string, with `field` assumed to be the default field and omitted.

Specified by:
  `toString` in class `Query`

### rewrite

public Query rewrite(IndexSearcher indexSearcher) throws IOException
Description copied from class: `Query`
Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.

Callers are expected to call `rewrite` multiple times if necessary, until the rewritten query is the same as the original query.

The rewrite process may be able to make use of IndexSearcher's executor and be executed in parallel if the executor is provided.

Overrides:
  `rewrite` in class `Query`
Throws:
  `IOException`
See Also:
  - `IndexSearcher.rewrite(Query)`

### createWeight

public Weight createWeight(IndexSearcher searcher, ScoreMode scoreMode, float boost) throws IOException
Description copied from class: `Query`
Expert: Constructs an appropriate Weight implementation for this query.

Only implemented by primitive queries, which re-write to themselves.

Overrides:
  `createWeight` in class `Query`
Parameters:
  `scoreMode` - How the produced scorers will be consumed.
  `boost` - The boost that is propagated by the parent queries.
Throws:
  `IOException`